#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

char buf[1024];

void quote(void)
{
    char *p;
    int c, l;
    
    c = 0;
    for(p = buf; *p; p++)
    {
	if(isspace((int)(*p)))
	    c++;
	if((*p == '\"') || (*p == '\\'))
	{
	    memmove(p + 1, p, strlen(p) + 1);
	    *p = '\\';
	    p++;
	}
    }
    if(c > 3) /* Whatever */
    {
	l = strlen(buf);
	memmove(buf + 1, buf, l);
	*buf = '\"';
        buf[l + 1] = '\"';
	buf[l + 2] = 0;
    } else {
	for(p = buf; *p; p++)
	{
	    if(isspace((int)(*p)))
	    {
		memmove(p + 1, p, strlen(p) + 1);
		*p = '\\';
		p++;
	    }
	}
    }
}

int main(int argc, char **argv)
{
    int i, o, u;
    int wc, cc;
    FILE *bin, *text;
    
    if(argc < 2)
    {
	printf("usage: %s num\n num is the number of commands to be generated.\n", argv[0]);
	exit(1);
    }
    if((bin = fopen("bincmds", "w")) == NULL)
    {
	perror("bincmds");
	exit(1);
    }
    if((text = fopen("txtcmds", "w")) == NULL)
    {
	perror("txtcmds");
	exit(1);
    }
    for(i = atoi(argv[1]); i > 0; i--)
    {
	wc = (rand() % 8) + 8;
	fwrite(&wc, 4, 1, bin);
	for(o = 0; o < wc; o++)
	{
	    cc = (rand() % 30) + 1;
	    for(u = 0; u < cc; u++)
		buf[u] = (rand() % 95) + 32;
	    buf[cc] = 0;
	    fwrite(&cc, 4, 1, bin);
	    fwrite(buf, 1, cc, bin);
	    quote();
	    fputs(buf, text);
	    if(o < wc - 1)
		fputc(' ', text);
	}
	fputc(10, text);
    }
    return(0);
}
